import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class Main {
  public static void main(String[] a) throws Exception {
    JPAUtil util = new JPAUtil();

    EntityManagerFactory emf = Persistence.createEntityManagerFactory("ProfessorService");
    EntityManager em = emf.createEntityManager();
    ProfessorService service = new ProfessorService(em);

    em.getTransaction().begin();
    Professor emp = service.createProfessor(158, "AAA", 45000,ProfessorType.CONTRACT_EMPLOYEE);
    em.getTransaction().commit();
    System.out.println("Persisted " + emp);

    util.checkData("select * from Professor");

    // remove an employee
    em.getTransaction().begin();
    service.removeProfessor(158);
    em.getTransaction().commit();
    System.out.println("Removed Professor 158");

    util.checkData("select * from Professor");
    
    em.close();
    emf.close();
  }
}