import static javax.persistence.EnumType.STRING;

import javax.persistence.Entity;
import javax.persistence.Enumerated;
import javax.persistence.Id;


@Entity
public class Professor {
  @Id
  private int id;
  private String name;
  private long salary;
  private ProfessorType type;

  @Enumerated(STRING)
  private ProfessorType previousType;

  public Professor() {
  }

  public Professor(int id) {
    this.id = id;
  }

  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public long getSalary() {
    return salary;
  }

  public void setSalary(long salary) {
    this.salary = salary;
  }

  public ProfessorType getType() {
    return type;
  }

  public void setType(ProfessorType type) {
    this.previousType = this.type;
    if (this.previousType == null) {
      this.previousType = type;
    }
    this.type = type;
  }

  public ProfessorType getPreviousType() {
    return previousType;
  }

  public String toString() {
    return "Professor id: " + getId() + " name: " + getName() + " salary: " + getSalary();
  }
}
